#include <minigui.ch>

Set Procedure To GridPrint.Prg

function main
private headarr := {"Numeric","Date","Character","Logical","Numeric","Numeric","Numeric","Numeric","Numeric"}
private sizearr := {5,10,30,5,10,10,10,10,10}
private samarr := {}

set century on
define window sample at 0,0 width 800 height 600 main
   define grid g
      row 10
      col 10
      width 780
      height 500
      headers headarr
      justify {0,0,0,0,1,1,1,1,1}
      widths {50,100,300,50,100,100,100,100,100}
   end grid
   define button print
      row 510
      col 10
      caption "Print"
      action printsamplegrid()
   end button
end window
for i := 1 to 1000
    sample.g.additem({str(i),dtoc(date()),convert(i),iif(.t.,"True","False"),str(i^2),str(i),str(i^0.5),str(120000),str(334345)})
next i
sample.center
sample.activate
return nil

function printsamplegrid

	* For this sample we will assume that until two user parameters can be
	* used

	Sample.g.Print ( headarr,{"N","D","C","C","N","N","N","N","N"} )

/*
	Or

	Domethod ( 'Sample' , 'g' , 'Print' , headarr , {"N","D","C","C","N","N","N","N","N"} )

*/

return nil


Function BIGELEM(aArray)
local nLongest := 0
local nIterator
for nIterator = 1 to len(aArray)
   if valtype(aArray[nIterator])=="C"
     nLongest := max(nLongest,len(aArray[nIterator]))
   endif
next
return nLongest

FUNCTION PROPERstring(cInString)
local nIter,cOutString,cThisChar,lCapNext

lCapNext   := .T.
cOutString := ''

*- loop for length of string
FOR nIter = 1 TO LEN(cInString)
  cThisChar  := SUBST(cInString,nIter,1)
  *- if its not alpha,cap the next alpha character
  IF !UPPER(cThisChar) $ "ABCDEFGHIJKLMNOPQRSTUVWXYZ'"
    lCapNext := .T.
  ELSE
    *- capitalise it or lower() it accordingly
    IF lCapNext
      cThisChar := UPPER(cThisChar)
      lCapNext  := .F.
    ELSE
      cThisChar := LOWER(cThisChar)
    ENDIF
  ENDIF
  *- add it to the cOutString
  cOutString += cThisChar
NEXT
RETURN cOutString


function convert(num)
local digit := {}
local x := 0
local num1 := space(100)
local st := space(200)
local a := 0
local h := 0
local m := 0
num1 := str(num)
h = len(trim(num1))
x = h
m = 1
do while x > 0
   if substr(num1,x,1) = '.'
      d = m
      x = x - 1
      h = h - 1
   endi
   aadd(digit,val(substr(num1,x,1)))
   x = x - 1
   m = m + 1
enddo
do while m <= 16
   aadd(digit,0)
   m = m + 1
enddo
a = h
stor space(200) to st
if digit[16] > 0
   if digit[16] = 1
      st = trim(st) + ' ' + spldig2(digit[15]) + " Crores"
   else
      if digit[15] = 0
         st = trim(st) + ' ' + dig2(digit[16]) + " Crores"
      else
      st = trim(st) + ' ' + dig2(digit[16]) + ' ' + dig1(digit[15]) + " Crores"
      endif
   endif
else
   if digit[15] > 0
      if digit[15] = 1
         st = trim(st) + "One Crore"
      else
         st = trim(st) + ' ' + dig1(digit[15]) + " Crores"
      endif
   endif
endif
if digit[14] > 0
   if digit[14] = 1
      st = trim(st) + ' ' + spldig2(digit[13]) + " Lakhs"
   else
      if digit[13] = 0
         st = trim(st) + ' ' + dig2(digit[14]) + " Lakhs"
      else
         st = trim(st) + ' ' + dig2(digit[14]) + ' ' + dig1(digit[13]) + " Lakhs"
      endif
   endif
else
   if digit[13] > 0
      if digit[13] = 1
         st = trim(st) + " One Lakh"
      else
         st = trim(st) + ' ' + dig1(digit[13]) + " Lakhs"
      endif
   endif
endif
if digit[12] > 0
   if digit[12] = 1
      st = trim(st) + ' ' + spldig2(digit[11]) + " Thousand"
   else
      if digit[11] = 0
         st = trim(st) + ' ' + dig2(digit[12]) + " Thousand"
      else
         st = trim(st) + ' ' + dig2(digit[12]) + ' ' + dig1(digit[11]) + " Thousand"
      endif
   endif
else
   if digit[11] > 0
      if digit[11] = 1
         st = trim(st) + " One Thousand"
      else
         st = trim(st) + ' ' + dig1(digit[11]) + " Thousand"
      endif
   endif
endif
if digit[10] > 0
   st = trim(st) + ' ' + dig1(digit[10]) + " Hundred"
endif
if (digit[16] > 0 .or. digit[15] > 0 .or. digit[14] > 0 .or. digit[13] > 0 .or. digit[12] > 0 .or. digit[11] > 0 .or. digit[10] > 0) .and. (digit[9] > 0 .or. digit[8] > 0)
   st = trim(st) + " and"
else
   if digit[16] > 0 .or. digit[15] > 0 .or. digit[14] > 0 .or. digit[13] > 0 .or. digit[12] > 0 .or. digit[11] > 0 .or. digit[10] > 0
      st = trim(st) + " Crores"
   endif
endif
if digit[9] > 0
   if digit[9] = 1
      st = trim(st) + ' ' + spldig2(digit[8]) + " Crores"
   else
      if digit[8] = 0
         st = trim(st) + ' ' + dig2(digit[9]) + " Crores"
      else
         st = trim(st) + ' ' + dig2(digit[9]) + ' ' + dig1(digit[8]) + " Crores"
      endif
   endif
else
   if digit[8] > 0
      if digit[8] = 1
         st = trim(st) + "One Crore"
      else
         st = trim(st) + ' ' + dig1(digit[8]) + " Crores"
      endif
   endif
endif
if digit[7] > 0
   if digit[7] = 1
      st = trim(st) + ' ' + spldig2(digit[6]) + " Lakhs"
   else
      if digit[6] = 0
         st = trim(st) + ' ' + dig2(digit[7]) + " Lakhs"
      else
         st = trim(st) + ' ' + dig2(digit[7]) + ' ' + dig1(digit[6]) + " Lakhs"
      endif
   endif
else
   if digit[6] > 0
      if digit[6] = 1
         st = trim(st) + " One Lakh"
      else
         st = trim(st) + ' ' + dig1(digit[6]) + " Lakhs"
      endif
   endif
endif
if digit[5] > 0
   if digit[5] = 1
      st = trim(st) + ' ' + spldig2(digit[4]) + " Thousand"
   else
      if digit[4] = 0
         st = trim(st) + ' ' + dig2(digit[5]) + " Thousand"
      else
         st = trim(st) + ' ' + dig2(digit[5]) + ' ' + dig1(digit[4]) + " Thousand"
      endif
   endif
else
   if digit[4] > 0
      if digit[4] = 1
         st = trim(st) + " One Thousand"
      else
         st = trim(st) + ' ' + dig1(digit[4]) + " Thousand"
      endif
   endif
endif
if digit[3] > 0
   st = trim(st) + ' ' + dig1(digit[3]) + " Hundred"
endif
if (digit[16] > 0 .or. digit[15] > 0 .or. digit[14] > 0 .or. digit[13] > 0 .or. digit[12] > 0 .or. digit[11] > 0 .or. digit[10] > 0 .or. digit[9] > 0 .or. digit[8] > 0 .or. digit[7] > 0 .or. digit[6] > 0 .or. digit[5] > 0 .or. digit[4] > 0 .or. digit[3] > 0) .and. (digit[2] > 0 .or. digit[1] > 0)
    st = trim(st) + " and"
endif
if digit[2] > 0
   if digit[2] = 1
      st = trim(st) + ' ' + spldig2(digit[1])
   else
      if digit[1] = 0
         st = trim(st) + ' ' + dig2(digit[2])
      else
         st = trim(st) + ' ' + dig2(digit[2]) + ' ' + dig1(digit[1])
      endif
   endif
else
   if digit[1] > 0
      st = trim(st) + ' ' + dig1(digit[1])
   endif
endif
return st

function dig1(b)
local string := space(20)
local x := b
do case
        case x = 1
                string = "One"
        case x = 2
                string = "Two"
        case x = 3
                string = "Three"
        case x = 4
                string = "Four"
        case x = 5
                string = "Five"
        case x = 6
                string = "Six"
        case x = 7
                string = "Seven"
        case x = 8
                string = "Eight"
        case x = 9
                string = "Nine"
endcase
return string

Function dig2(b)
local string := space(20) 
local x := b
do case
        case x = 2
                string = "Twenty"
        case x = 3
                string = "Thirty"
        case x = 4
                string = "Forty"
        case x = 5
                string = "Fifty"
        case x = 6
                string = "Sixty"
        case x = 7
                string = "Seventy"
        case x = 8
                string = "Eighty"
        case x = 9
                string = "Ninety"
endcase
return string

function spldig2(b)
local string := space(20) 
local x := b
do case
        case x = 0
                string = "Ten"
        case x = 1
                string = "Eleven"
        case x = 2
                string = "Twelve"
        case x = 3
                string = "Thirteen"
        case x = 4
                string = "Fourteen"
        case x = 5
                string = "Fifteen"
        case x = 6
                string = "Sixteen"
        case x = 7
                string = "Seventeen"
        case x = 8
                string = "Eighteen"
        case x = 9
                string = "Nineteen"
endcase
return string

